/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8b Professional

Project : Home Tormentor 
Version : 
Date    : 29.01.2007
Author  : Yuri Ryzhenko                          
Company : Apagon                           
Comments: 


Chip type           : ATmega48
Clock frequency     : 14,745600 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128     




7  0xAA
6  0xAA
5  Command  0  1  2  3  4  5
4  Byte 0      H  L  H
3  Byte 1      L     L
2  Byte 2
1  Byte 3
0  CRC



*****************************************************/

#include <mega48.h>
#include <stdio.h>
#include <delay.h>

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)


#define DCDC_ON PORTB.1=0
#define DCDC_OFF PORTB.1=1
#define HV_OUT_ON PORTB.2=1
#define HV_OUT_OFF PORTB.2=0
#define DisCharg_ON PORTD.6=1  
#define DisCharg_OFF PORTD.6=0



unsigned int HV_level=70; // U=HV_level/2,2
unsigned char TIME_of_strike=100;
unsigned int Resist_of_skin;
unsigned char Command_byte[5], rx_bufer[8];


bit New_command_frame;




//************************************************************************
//************************************************************************
//************************************************************************
unsigned char temp;
   //   UART   
   temp=UDR0;
   //UDR0=temp;   //
   
   //  
   rx_bufer[7]=rx_bufer[6];
   rx_bufer[6]=rx_bufer[5];
   rx_bufer[5]=rx_bufer[4];
   rx_bufer[4]=rx_bufer[3];
   rx_bufer[3]=rx_bufer[2];
   rx_bufer[2]=rx_bufer[1];
   rx_bufer[1]=rx_bufer[0];    
   
   rx_bufer[0]=temp;
   
   //  
   if(rx_bufer[7]==0xAA){
      if(rx_bufer[6]==0xAA){
      temp=0;
      temp^=rx_bufer[5];
      temp^=rx_bufer[4];
      temp^=rx_bufer[3];
      temp^=rx_bufer[2];
      temp^=rx_bufer[1];
         if(rx_bufer[0]==0xAA/*temp*/){ //    ,
         // 0xAA   
            Command_byte[0]=rx_bufer[5]; //Command
            Command_byte[1]=rx_bufer[4]; //Byte 0
            Command_byte[2]=rx_bufer[3]; //Byte 1
            Command_byte[3]=rx_bufer[2]; //Byte 2
            Command_byte[4]=rx_bufer[1]; //Byte 3
            New_command_frame=1;
         }
      }  
   }     
}
//************************************************************************

//************************************************************************
//     - 
//************************************************************************
void electro_shock (unsigned char TIME_of_strike){
   HV_OUT_ON;
   delay_ms(TIME_of_strike);
   HV_OUT_OFF;
}


//************************************************************************







//************************************************************************
#define ADC_VREF_TYPE 0xC0

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}
//************************************************************************












//************************************************************************
//***                                           **************************
//***                                           **************************
//***                MAIN                       **************************
//***                                           **************************
//***                                           **************************
//************************************************************************
void main(void)
{
// Declare your local variables here
unsigned int ADC_temp [16], ADC1_temp [16];
volatile unsigned int ADC, ADC1;
char i;






// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=1 State0=T 
PORTB=0x02;
DDRB=0b00000110;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=P State2=P State1=T State0=T 
PORTC=0x0C;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=0 State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0b01010000;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART0 Mode: Asynchronous
// USART Baud rate: 9600
UCSR0A=0x00;
UCSR0B=0x98;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x5F;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 115,200 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC Auto Trigger Source: None
// Digital input buffers on ADC0: Off, ADC1: Off, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
DIDR0=0x03;
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x87;

// Global enable interrupts
#asm("sei")


while (1)
 {
//************************************************************************
//        
//************************************************************************
ADC=0;
   for (i=0;i<32;i++){
      ADC+=read_adc(0);
   }
   ADC>>=5;       
   
   //   
      for (i=0;i<15;i++){
         ADC_temp [i]=ADC_temp [i+1];
      }
      ADC_temp [15]=ADC;      

   //      16    
      ADC=0;
      for (i=0;i<16;i++){
         ADC=ADC+ADC_temp [i];      
      }
      ADC=ADC>>4;

   
   if (ADC<HV_level)DisCharg_OFF, DCDC_ON;
   else{
      DCDC_OFF;
      if (ADC>(HV_level+10)) DisCharg_ON;
      else DisCharg_OFF;
   } 
   
//    ADC=(ADC*10)/22;
//    printf("%u\r",ADC); 
//************************************************************************



//************************************************************************
//       
//************************************************************************
ADC1=0;
   for (i=0;i<32;i++){
      ADC1+=read_adc(1);
   }
   ADC1>>=5;       
   
   //   
      for (i=0;i<15;i++){
         ADC1_temp [i]=ADC1_temp [i+1];
      }
      ADC1_temp [15]=ADC1;      

   //      16    
      ADC1=0;
      for (i=0;i<16;i++){
         ADC1=ADC1+ADC1_temp [i];      
      }
      ADC1=ADC1>>4;
      Resist_of_skin=ADC1;
   
//************************************************************************

//************************************************************************
//************************************************************************
//***                                    *********************************
//***      UART    *********************************
//***                                    *********************************
//************************************************************************
//************************************************************************
if (New_command_frame){
   New_command_frame=0;
   switch (Command_byte[0]) {
    case 0: //   
       #asm("cli")
       electro_shock (TIME_of_strike);
       printf("OK\r"); 
       #asm("sei") 
    break;
    
    case 1: //   
      HV_level=Command_byte[1];
      HV_level=HV_level<<8;
      HV_level=HV_level+Command_byte[2];
      HV_level=(HV_level*22)/10; 
      printf("OK\r");
    break;
    
    case 2: //      .
      TIME_of_strike=Command_byte[1]; 
      printf("OK\r");
    break;
    
    case 3: //    
      ADC=(ADC*10)/22;
      printf("%u\r",ADC);
    break;
    
    case 4: //    
      printf("%u\r",ADC1);
    break;
    
    case 5: //  
      printf("%u\r",TIME_of_strike);
    break;
    
    case 6: //   
      printf("%u\r",HV_level);
    break;
       
    default:
    printf("NAK\r");
    };

}
//************************************************************************   
   
   
//    ADC=(ADC*10)/22;
//     
//    printf ("ADC0=%u\t\t",ADC);
//    printf ("ADC1=%u\r",ADC1);

 };//END of MAIN (while)
}//END of MAIN Function
